/* new-messages-monitor.c generated by valac 0.20.0, the Vala compiler
 * generated from new-messages-monitor.vala, do not modify */

/* Copyright 2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* NewMessagesMonitor is a central data store for new message information that the various*/
/* notification methods (libnotify, libindicate, libunity, etc.) can monitor to do their thing.*/
/* Subclasses should trap the "notify::count" signal and use that to perform whatever magic*/
/* they need for their implementation, or trap "new-messages" to receive notifications of the emails*/
/* themselves as they're added.  In the latter case, subscribers should add required Email.Field*/
/* flags to the object with add_required_fields().*/

#include <glib.h>
#include <glib-object.h>
#include "geary-static.h"
#include <gee.h>
#include <gio/gio.h>


#define TYPE_NEW_MESSAGES_MONITOR (new_messages_monitor_get_type ())
#define NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor))
#define NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))
#define IS_NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_MESSAGES_MONITOR))
#define IS_NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_MESSAGES_MONITOR))
#define NEW_MESSAGES_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))

typedef struct _NewMessagesMonitor NewMessagesMonitor;
typedef struct _NewMessagesMonitorClass NewMessagesMonitorClass;
typedef struct _NewMessagesMonitorPrivate NewMessagesMonitorPrivate;

#define NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION (new_messages_monitor_monitor_information_get_type ())
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformation))
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformationClass))
#define NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION))
#define NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION))
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformationClass))

typedef struct _NewMessagesMonitorMonitorInformation NewMessagesMonitorMonitorInformation;
typedef struct _NewMessagesMonitorMonitorInformationClass NewMessagesMonitorMonitorInformationClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NewMessagesMonitorMonitorInformationPrivate NewMessagesMonitorMonitorInformationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NewMessagesMonitorDoProcessNewEmailData NewMessagesMonitorDoProcessNewEmailData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NewMessagesMonitor {
	GearyBaseObject parent_instance;
	NewMessagesMonitorPrivate * priv;
};

struct _NewMessagesMonitorClass {
	GearyBaseObjectClass parent_class;
};

typedef gboolean (*NewMessagesMonitorShouldNotifyNewMessages) (GearyFolder* folder, void* user_data);
struct _NewMessagesMonitorPrivate {
	GearyEmailField _required_fields;
	gint _total_count;
	GearyFolder* _last_new_message_folder;
	GearyEmail* _last_new_message;
	GeeHashMap* folder_information;
	NewMessagesMonitorShouldNotifyNewMessages _should_notify_new_messages;
	gpointer _should_notify_new_messages_target;
};

struct _NewMessagesMonitorMonitorInformation {
	GearyBaseObject parent_instance;
	NewMessagesMonitorMonitorInformationPrivate * priv;
	GearyFolder* folder;
	GCancellable* cancellable;
	gint count;
	GeeHashSet* new_ids;
};

struct _NewMessagesMonitorMonitorInformationClass {
	GearyBaseObjectClass parent_class;
};

struct _NewMessagesMonitorDoProcessNewEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NewMessagesMonitor* self;
	GearyFolder* folder;
	GeeCollection* email_ids;
	GeeHashMap* _tmp0_;
	GearyFolder* _tmp1_;
	gpointer _tmp2_;
	NewMessagesMonitorMonitorInformation* info;
	GearyFolder* _tmp3_;
	GeeCollection* _tmp4_;
	GearyEmailField _tmp5_;
	NewMessagesMonitorMonitorInformation* _tmp6_;
	GCancellable* _tmp7_;
	GeeList* _tmp8_;
	GeeList* list;
	gboolean _tmp9_;
	GeeList* _tmp10_;
	GeeList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	GeeCollection* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	NewMessagesMonitorMonitorInformation* _tmp18_;
	GeeList* _tmp19_;
	GeeList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	NewMessagesMonitorMonitorInformation* _tmp23_;
	gint _tmp24_;
	GearyFolder* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GError* err;
	GError* _tmp28_;
	const gchar* _tmp29_;
	GError * _inner_error_;
};


static gpointer new_messages_monitor_parent_class = NULL;
static gpointer new_messages_monitor_monitor_information_parent_class = NULL;

GType new_messages_monitor_get_type (void) G_GNUC_CONST;
static GType new_messages_monitor_monitor_information_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define NEW_MESSAGES_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorPrivate))
enum  {
	NEW_MESSAGES_MONITOR_DUMMY_PROPERTY,
	NEW_MESSAGES_MONITOR_REQUIRED_FIELDS,
	NEW_MESSAGES_MONITOR_TOTAL_COUNT,
	NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER,
	NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE
};
NewMessagesMonitor* new_messages_monitor_new (NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target);
NewMessagesMonitor* new_messages_monitor_construct (GType object_type, NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target);
gboolean new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self, GearyFolder* folder);
void new_messages_monitor_add_folder (NewMessagesMonitor* self, GearyFolder* folder, GCancellable* cancellable);
static void new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* email_ids);
static void _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender, GeeCollection* ids, gpointer self);
static void new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self, GearyFolder* folder, GeeMap* ids);
static void _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender, GeeMap* map, gpointer self);
static void new_messages_monitor_on_email_removed (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* ids);
static void _new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender, GeeCollection* ids, gpointer self);
static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_new (GearyFolder* folder, GCancellable* cancellable);
static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_construct (GType object_type, GearyFolder* folder, GCancellable* cancellable);
void new_messages_monitor_remove_folder (NewMessagesMonitor* self, GearyFolder* folder);
gint new_messages_monitor_get_total_count (NewMessagesMonitor* self);
static void new_messages_monitor_set_total_count (NewMessagesMonitor* self, gint value);
GeeCollection* new_messages_monitor_get_folders (NewMessagesMonitor* self);
gint new_messages_monitor_get_new_message_count (NewMessagesMonitor* self, GearyFolder* folder);
void new_messages_monitor_add_required_fields (NewMessagesMonitor* self, GearyEmailField fields);
GearyEmailField new_messages_monitor_get_required_fields (NewMessagesMonitor* self);
static void new_messages_monitor_set_required_fields (NewMessagesMonitor* self, GearyEmailField value);
gboolean new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* ids);
static void new_messages_monitor_do_process_new_email (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* email_ids, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self, GAsyncResult* _res_);
static void new_messages_monitor_retire_new_messages (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* email_ids);
static void new_messages_monitor_do_process_new_email_data_free (gpointer _data);
static gboolean new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_);
static void new_messages_monitor_do_process_new_email_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void new_messages_monitor_new_messages (NewMessagesMonitor* self, NewMessagesMonitorMonitorInformation* info, GeeCollection* emails);
static void new_messages_monitor_set_last_new_message_folder (NewMessagesMonitor* self, GearyFolder* value);
static void new_messages_monitor_set_last_new_message (NewMessagesMonitor* self, GearyEmail* value);
static void new_messages_monitor_update_count (NewMessagesMonitor* self, NewMessagesMonitorMonitorInformation* info, gboolean arrived);
GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self);
void new_messages_monitor_clear_new_messages (NewMessagesMonitor* self, GearyFolder* folder);
void new_messages_monitor_clear_all_new_messages (NewMessagesMonitor* self);
GearyFolder* new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
enum  {
	NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_DUMMY_PROPERTY
};
static guint _geary_hashable_hash_func_ghash_func (gconstpointer key);
static gboolean _geary_equalable_equal_func_gequal_func (gconstpointer a, gconstpointer b);
static void new_messages_monitor_monitor_information_finalize (GObject* obj);
static void new_messages_monitor_finalize (GObject* obj);
static void _vala_new_messages_monitor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_new_messages_monitor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


NewMessagesMonitor* new_messages_monitor_construct (GType object_type, NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target) {
	NewMessagesMonitor * self = NULL;
	NewMessagesMonitorShouldNotifyNewMessages _tmp0_;
	void* _tmp0__target;
#line 58 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self = (NewMessagesMonitor*) geary_base_object_construct (object_type);
#line 59 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = should_notify_new_messages;
#line 59 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0__target = should_notify_new_messages_target;
#line 59 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_should_notify_new_messages = _tmp0_;
#line 59 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_should_notify_new_messages_target = _tmp0__target;
#line 58 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return self;
#line 205 "new-messages-monitor.c"
}


NewMessagesMonitor* new_messages_monitor_new (NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target) {
#line 58 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return new_messages_monitor_construct (TYPE_NEW_MESSAGES_MONITOR, should_notify_new_messages, should_notify_new_messages_target);
#line 212 "new-messages-monitor.c"
}


gboolean new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self, GearyFolder* folder) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NewMessagesMonitorShouldNotifyNewMessages _tmp1_;
	void* _tmp1__target;
#line 62 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), FALSE);
#line 62 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), FALSE);
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->_should_notify_new_messages;
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1__target = self->priv->_should_notify_new_messages_target;
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	if (_tmp1_ == NULL) {
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = TRUE;
#line 233 "new-messages-monitor.c"
	} else {
		NewMessagesMonitorShouldNotifyNewMessages _tmp2_;
		void* _tmp2__target;
		GearyFolder* _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp2_ = self->priv->_should_notify_new_messages;
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp2__target = self->priv->_should_notify_new_messages_target;
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp3_ = folder;
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp4_ = _tmp2_ (_tmp3_, _tmp2__target);
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = _tmp4_;
#line 249 "new-messages-monitor.c"
	}
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 63 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 255 "new-messages-monitor.c"
}


static void _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender, GeeCollection* ids, gpointer self) {
#line 69 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_locally_appended (self, _sender, ids);
#line 262 "new-messages-monitor.c"
}


static void _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender, GeeMap* map, gpointer self) {
#line 70 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_flags_changed (self, _sender, map);
#line 269 "new-messages-monitor.c"
}


static void _new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender, GeeCollection* ids, gpointer self) {
#line 71 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_removed (self, _sender, ids);
#line 276 "new-messages-monitor.c"
}


void new_messages_monitor_add_folder (NewMessagesMonitor* self, GearyFolder* folder, GCancellable* cancellable) {
	GeeHashMap* _tmp0_;
	GearyFolder* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GearyFolder* _tmp3_;
	GearyFolder* _tmp4_;
	GearyFolder* _tmp5_;
	GeeHashMap* _tmp6_;
	GearyFolder* _tmp7_;
	GearyFolder* _tmp8_;
	GCancellable* _tmp9_;
	NewMessagesMonitorMonitorInformation* _tmp10_;
	NewMessagesMonitorMonitorInformation* _tmp11_;
	GearyFolder* _tmp12_;
#line 66 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 66 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 66 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable));
#line 67 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 67 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = folder;
#line 67 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 67 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (!_tmp2_, "!folder_information.has_key(folder)");
#line 69 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = folder;
#line 69 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (_tmp3_, "email-locally-appended", (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self, 0);
#line 70 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = folder;
#line 70 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (_tmp4_, "email-flags-changed", (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self, 0);
#line 71 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = folder;
#line 71 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (_tmp5_, "email-removed", (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self, 0);
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = self->priv->folder_information;
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp7_ = folder;
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp8_ = folder;
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp9_ = cancellable;
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp10_ = new_messages_monitor_monitor_information_new (_tmp8_, _tmp9_);
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp11_ = _tmp10_;
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp7_, _tmp11_);
#line 73 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp11_);
#line 75 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp12_ = folder;
#line 75 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_emit_by_name (self, "folder-added", _tmp12_);
#line 340 "new-messages-monitor.c"
}


void new_messages_monitor_remove_folder (NewMessagesMonitor* self, GearyFolder* folder) {
	GeeHashMap* _tmp0_;
	GearyFolder* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GearyFolder* _tmp3_;
	guint _tmp4_ = 0U;
	GearyFolder* _tmp5_;
	guint _tmp6_ = 0U;
	GearyFolder* _tmp7_;
	guint _tmp8_ = 0U;
	gint _tmp9_;
	GeeHashMap* _tmp10_;
	GearyFolder* _tmp11_;
	gpointer _tmp12_ = NULL;
	NewMessagesMonitorMonitorInformation* _tmp13_;
	gint _tmp14_;
	GeeHashMap* _tmp15_;
	GearyFolder* _tmp16_;
	GearyFolder* _tmp17_;
#line 78 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 78 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 79 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 79 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = folder;
#line 79 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 79 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	if (!_tmp2_) {
#line 80 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		return;
#line 377 "new-messages-monitor.c"
	}
#line 82 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = folder;
#line 82 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-locally-appended", GEARY_TYPE_FOLDER, &_tmp4_, NULL, FALSE);
#line 82 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self);
#line 83 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = folder;
#line 83 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-flags-changed", GEARY_TYPE_FOLDER, &_tmp6_, NULL, FALSE);
#line 83 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self);
#line 84 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp7_ = folder;
#line 84 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-removed", GEARY_TYPE_FOLDER, &_tmp8_, NULL, FALSE);
#line 84 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self);
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp9_ = self->priv->_total_count;
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp10_ = self->priv->folder_information;
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp11_ = folder;
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp12_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_);
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp13_ = (NewMessagesMonitorMonitorInformation*) _tmp12_;
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp14_ = _tmp13_->count;
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_total_count (self, _tmp9_ - _tmp14_);
#line 86 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp13_);
#line 88 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp15_ = self->priv->folder_information;
#line 88 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp16_ = folder;
#line 88 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp16_, NULL);
#line 90 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp17_ = folder;
#line 90 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_emit_by_name (self, "folder-removed", _tmp17_);
#line 423 "new-messages-monitor.c"
}


GeeCollection* new_messages_monitor_get_folders (NewMessagesMonitor* self) {
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 93 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 94 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 94 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap));
#line 94 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 94 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 94 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 444 "new-messages-monitor.c"
}


gint new_messages_monitor_get_new_message_count (NewMessagesMonitor* self, GearyFolder* folder) {
	gint result = 0;
	GeeHashMap* _tmp0_;
	GearyFolder* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp3_;
	GearyFolder* _tmp4_;
	gpointer _tmp5_ = NULL;
	NewMessagesMonitorMonitorInformation* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 97 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 97 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), 0);
#line 98 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 98 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = folder;
#line 98 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 98 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (_tmp2_, "folder_information.has_key(folder)");
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = self->priv->folder_information;
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = folder;
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = (NewMessagesMonitorMonitorInformation*) _tmp5_;
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp7_ = _tmp6_->count;
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp8_ = _tmp7_;
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp6_);
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp8_;
#line 100 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 489 "new-messages-monitor.c"
}


void new_messages_monitor_add_required_fields (NewMessagesMonitor* self, GearyEmailField fields) {
	GearyEmailField _tmp0_;
	GearyEmailField _tmp1_;
#line 103 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 104 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 104 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = fields;
#line 104 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_required_fields (self, _tmp0_ | _tmp1_);
#line 504 "new-messages-monitor.c"
}


gboolean new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* ids) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	GearyFolder* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp3_;
	GearyFolder* _tmp4_;
	gpointer _tmp5_ = NULL;
	NewMessagesMonitorMonitorInformation* info;
#line 107 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), FALSE);
#line 107 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), FALSE);
#line 107 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (ids), FALSE);
#line 109 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 109 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = folder;
#line 109 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 109 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (_tmp2_, "folder_information.has_key(folder)");
#line 110 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = self->priv->folder_information;
#line 110 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = folder;
#line 110 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 110 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp5_;
#line 539 "new-messages-monitor.c"
	{
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _id_it;
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp6_ = ids;
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_id_it = _tmp7_;
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 552 "new-messages-monitor.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			GearyEmailIdentifier* id;
			NewMessagesMonitorMonitorInformation* _tmp12_;
			GeeHashSet* _tmp13_;
			GearyEmailIdentifier* _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = _id_it;
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (!_tmp9_) {
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 570 "new-messages-monitor.c"
			}
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp10_ = _id_it;
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			id = (GearyEmailIdentifier*) _tmp11_;
#line 113 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp12_ = info;
#line 113 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp13_ = _tmp12_->new_ids;
#line 113 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp14_ = id;
#line 113 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp15_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_);
#line 113 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (_tmp15_) {
#line 114 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				result = TRUE;
#line 114 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (id);
#line 114 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (_id_it);
#line 114 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (info);
#line 114 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				return result;
#line 598 "new-messages-monitor.c"
			}
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (id);
#line 602 "new-messages-monitor.c"
		}
#line 112 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_id_it);
#line 606 "new-messages-monitor.c"
	}
#line 117 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = FALSE;
#line 117 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 117 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 614 "new-messages-monitor.c"
}


static void new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* email_ids) {
	GearyFolder* _tmp0_;
	GeeCollection* _tmp1_;
#line 120 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 120 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 120 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (email_ids));
#line 122 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = folder;
#line 122 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = email_ids;
#line 122 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email (self, _tmp0_, _tmp1_, NULL, NULL);
#line 633 "new-messages-monitor.c"
}


static void new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self, GearyFolder* folder, GeeMap* ids) {
	GearyFolder* _tmp0_;
	GeeMap* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
#line 125 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 125 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 125 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_MAP (ids));
#line 127 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = folder;
#line 127 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = ids;
#line 127 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_map_get_keys (_tmp1_);
#line 127 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _tmp2_;
#line 127 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = _tmp3_;
#line 127 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 127 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp4_);
#line 663 "new-messages-monitor.c"
}


static void new_messages_monitor_on_email_removed (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* ids) {
	GearyFolder* _tmp0_;
	GeeCollection* _tmp1_;
#line 130 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 130 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 130 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (ids));
#line 131 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = folder;
#line 131 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = ids;
#line 131 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, _tmp0_, _tmp1_);
#line 682 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email_data_free (gpointer _data) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->folder);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_slice_free (NewMessagesMonitorDoProcessNewEmailData, _data_);
#line 697 "new-messages-monitor.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 704 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* email_ids, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	NewMessagesMonitor* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_ = g_slice_new0 (NewMessagesMonitorDoProcessNewEmailData);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, new_messages_monitor_do_process_new_email);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, new_messages_monitor_do_process_new_email_data_free);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = folder;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->folder);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->folder = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = email_ids;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->email_ids = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 743 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self, GAsyncResult* _res_) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 751 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_ = _user_data_;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->_source_object_ = source_object;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->_res_ = _res_;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 765 "new-messages-monitor.c"
}


static gboolean new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_) {
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	switch (_data_->_state_) {
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case 0:
#line 774 "new-messages-monitor.c"
		goto _state_0;
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case 1:
#line 778 "new-messages-monitor.c"
		goto _state_1;
		default:
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_assert_not_reached ();
#line 783 "new-messages-monitor.c"
	}
	_state_0:
#line 136 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp0_ = _data_->self->priv->folder_information;
#line 136 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp1_ = _data_->folder;
#line 136 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp2_ = NULL;
#line 136 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _data_->_tmp1_);
#line 136 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_data_->info = (NewMessagesMonitorMonitorInformation*) _data_->_tmp2_;
#line 796 "new-messages-monitor.c"
	{
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp3_ = _data_->folder;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp4_ = _data_->email_ids;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp5_ = _data_->self->priv->_required_fields;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp6_ = _data_->info;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp7_ = _data_->_tmp6_->cancellable;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_state_ = 1;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		geary_folder_list_email_by_sparse_id_async (_data_->_tmp3_, _data_->_tmp4_, _data_->_tmp5_, GEARY_FOLDER_LIST_FLAGS_NONE, _data_->_tmp7_, new_messages_monitor_do_process_new_email_ready, _data_);
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 814 "new-messages-monitor.c"
		_state_1:
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp8_ = NULL;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp8_ = geary_folder_list_email_by_sparse_id_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error_);
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->list = _data_->_tmp8_;
#line 139 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		if (_data_->_inner_error_ != NULL) {
#line 824 "new-messages-monitor.c"
			goto __catch54_g_error;
		}
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp10_ = _data_->list;
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp10_ == NULL) {
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp9_ = TRUE;
#line 833 "new-messages-monitor.c"
		} else {
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp11_ = _data_->list;
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp12_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEE_TYPE_COLLECTION, GeeCollection));
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp9_ = _data_->_tmp13_ == 0;
#line 843 "new-messages-monitor.c"
		}
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp14_ = _data_->_tmp9_;
#line 141 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp14_) {
#line 142 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp15_ = _data_->email_ids;
#line 142 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp16_ = gee_collection_get_size (_data_->_tmp15_);
#line 142 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 142 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			g_debug ("new-messages-monitor.vala:142: Warning: %d new emails, but none could " \
"be listed", _data_->_tmp17_);
#line 144 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (_data_->list);
#line 144 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (_data_->info);
#line 144 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (_data_->_state_ == 0) {
#line 144 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 865 "new-messages-monitor.c"
			} else {
#line 144 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				g_simple_async_result_complete (_data_->_async_result);
#line 869 "new-messages-monitor.c"
			}
#line 144 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			g_object_unref (_data_->_async_result);
#line 144 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			return FALSE;
#line 875 "new-messages-monitor.c"
		}
#line 147 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp18_ = _data_->info;
#line 147 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp19_ = _data_->list;
#line 147 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_new_messages (_data_->self, _data_->_tmp18_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp19_, GEE_TYPE_COLLECTION, GeeCollection));
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp20_ = _data_->list;
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp21_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp20_, GEE_TYPE_COLLECTION, GeeCollection));
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp23_ = _data_->info;
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp24_ = _data_->_tmp23_->count;
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp25_ = _data_->folder;
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp26_ = NULL;
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp26_ = geary_folder_to_string (_data_->_tmp25_);
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp27_ = _data_->_tmp26_;
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:149: do_process_new_email: %d messages liste" \
"d, %d unread in folder %s", _data_->_tmp22_, _data_->_tmp24_, _data_->_tmp27_);
#line 149 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_free0 (_data_->_tmp27_);
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_data_->list);
#line 907 "new-messages-monitor.c"
	}
	goto __finally54;
	__catch54_g_error:
	{
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->err = _data_->_inner_error_;
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_inner_error_ = NULL;
#line 152 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp28_ = _data_->err;
#line 152 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp29_ = _data_->_tmp28_->message;
#line 152 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:152: Unable to notify of new email: %s", _data_->_tmp29_);
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_error_free0 (_data_->err);
#line 924 "new-messages-monitor.c"
	}
	__finally54:
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	if (_data_->_inner_error_ != NULL) {
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_data_->info);
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_clear_error (&_data_->_inner_error_);
#line 138 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 937 "new-messages-monitor.c"
	}
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->info);
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	if (_data_->_state_ == 0) {
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 945 "new-messages-monitor.c"
	} else {
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 949 "new-messages-monitor.c"
	}
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_unref (_data_->_async_result);
#line 134 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return FALSE;
#line 955 "new-messages-monitor.c"
}


static void new_messages_monitor_new_messages (NewMessagesMonitor* self, NewMessagesMonitorMonitorInformation* info, GeeCollection* emails) {
	NewMessagesMonitorMonitorInformation* _tmp38_;
#line 156 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 156 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION (info));
#line 156 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (emails));
#line 967 "new-messages-monitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _email_it;
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = emails;
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_email_it = _tmp1_;
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 980 "new-messages-monitor.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			GearyEmail* email;
			GearyEmail* _tmp6_;
			GearyEmailField _tmp7_;
			GearyEmailField _tmp8_;
			GearyEmailField _tmp9_;
			gboolean _tmp10_ = FALSE;
			NewMessagesMonitorMonitorInformation* _tmp20_;
			GeeHashSet* _tmp21_;
			GearyEmail* _tmp22_;
			GearyEmailIdentifier* _tmp23_;
			GearyEmailIdentifier* _tmp24_;
			gboolean _tmp25_ = FALSE;
			GearyEmail* _tmp26_;
			GearyEmailFlags* _tmp27_;
			GearyEmailFlags* _tmp28_;
			gboolean _tmp29_ = FALSE;
			NewMessagesMonitorMonitorInformation* _tmp30_;
			GearyFolder* _tmp31_;
			GearyEmail* _tmp32_;
			NewMessagesMonitorMonitorInformation* _tmp33_;
			GeeHashSet* _tmp34_;
			GearyEmail* _tmp35_;
			GearyEmailIdentifier* _tmp36_;
			GearyEmailIdentifier* _tmp37_;
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp2_ = _email_it;
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (!_tmp3_) {
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 1017 "new-messages-monitor.c"
			}
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _email_it;
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			email = (GearyEmail*) _tmp5_;
#line 158 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = email;
#line 158 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = geary_email_get_fields (_tmp6_);
#line 158 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = _tmp7_;
#line 158 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp9_ = self->priv->_required_fields;
#line 158 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp10_ = geary_email_field_fulfills (_tmp8_, _tmp9_);
#line 158 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (!_tmp10_) {
#line 1037 "new-messages-monitor.c"
				GearyEmail* _tmp11_;
				GearyEmailIdentifier* _tmp12_;
				GearyEmailIdentifier* _tmp13_;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_;
				GearyEmail* _tmp16_;
				GearyEmailField _tmp17_;
				GearyEmailField _tmp18_;
				GearyEmailField _tmp19_;
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp11_ = email;
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp12_ = geary_email_get_id (_tmp11_);
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp13_ = _tmp12_;
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp14_ = geary_email_identifier_to_string (_tmp13_);
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp15_ = _tmp14_;
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp16_ = email;
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp17_ = geary_email_get_fields (_tmp16_);
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp18_ = _tmp17_;
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp19_ = self->priv->_required_fields;
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				g_debug ("new-messages-monitor.vala:159: Warning: new message %s (%Xh) does not " \
"fulfill NewMessagesMonitor required fields of %Xh", _tmp15_, (guint) _tmp18_, (guint) _tmp19_);
#line 159 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_g_free0 (_tmp15_);
#line 1069 "new-messages-monitor.c"
			}
#line 163 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp20_ = info;
#line 163 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp21_ = _tmp20_->new_ids;
#line 163 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp22_ = email;
#line 163 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp23_ = geary_email_get_id (_tmp22_);
#line 163 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp24_ = _tmp23_;
#line 163 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp25_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp24_);
#line 163 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (_tmp25_) {
#line 164 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 164 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				continue;
#line 1089 "new-messages-monitor.c"
			}
#line 166 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp26_ = email;
#line 166 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp27_ = geary_email_get_email_flags (_tmp26_);
#line 166 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp28_ = _tmp27_;
#line 166 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp29_ = geary_email_flags_is_unread (_tmp28_);
#line 166 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (!_tmp29_) {
#line 167 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 167 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				continue;
#line 1105 "new-messages-monitor.c"
			}
#line 169 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp30_ = info;
#line 169 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp31_ = _tmp30_->folder;
#line 169 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_set_last_new_message_folder (self, _tmp31_);
#line 170 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp32_ = email;
#line 170 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_set_last_new_message (self, _tmp32_);
#line 172 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp33_ = info;
#line 172 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp34_ = _tmp33_->new_ids;
#line 172 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp35_ = email;
#line 172 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp36_ = geary_email_get_id (_tmp35_);
#line 172 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp37_ = _tmp36_;
#line 172 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp37_);
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email);
#line 1131 "new-messages-monitor.c"
		}
#line 157 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_it);
#line 1135 "new-messages-monitor.c"
	}
#line 175 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp38_ = info;
#line 175 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, _tmp38_, TRUE);
#line 1141 "new-messages-monitor.c"
}


static void new_messages_monitor_retire_new_messages (NewMessagesMonitor* self, GearyFolder* folder, GeeCollection* email_ids) {
	GeeHashMap* _tmp0_;
	GearyFolder* _tmp1_;
	gpointer _tmp2_ = NULL;
	NewMessagesMonitorMonitorInformation* info;
	NewMessagesMonitorMonitorInformation* _tmp20_;
#line 178 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 178 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 178 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (email_ids));
#line 180 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 180 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = folder;
#line 180 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 180 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp2_;
#line 1165 "new-messages-monitor.c"
	{
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _email_id_it;
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp3_ = email_ids;
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_email_id_it = _tmp4_;
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1178 "new-messages-monitor.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			GearyEmailIdentifier* email_id;
			gboolean _tmp9_ = FALSE;
			GearyEmail* _tmp10_;
			gboolean _tmp16_;
			NewMessagesMonitorMonitorInformation* _tmp17_;
			GeeHashSet* _tmp18_;
			GearyEmailIdentifier* _tmp19_;
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = _email_id_it;
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (!_tmp6_) {
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 1198 "new-messages-monitor.c"
			}
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = _email_id_it;
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			email_id = (GearyEmailIdentifier*) _tmp8_;
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp10_ = self->priv->_last_new_message;
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (_tmp10_ != NULL) {
#line 1210 "new-messages-monitor.c"
				GearyEmail* _tmp11_;
				GearyEmailIdentifier* _tmp12_;
				GearyEmailIdentifier* _tmp13_;
				GearyEmailIdentifier* _tmp14_;
				gboolean _tmp15_ = FALSE;
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp11_ = self->priv->_last_new_message;
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp12_ = geary_email_get_id (_tmp11_);
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp13_ = _tmp12_;
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp14_ = email_id;
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp15_ = geary_email_identifier_equals (_tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEARY_TYPE_EQUALABLE, GearyEqualable));
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp9_ = _tmp15_;
#line 1228 "new-messages-monitor.c"
			} else {
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				_tmp9_ = FALSE;
#line 1232 "new-messages-monitor.c"
			}
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp16_ = _tmp9_;
#line 183 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (_tmp16_) {
#line 184 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message_folder (self, NULL);
#line 185 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message (self, NULL);
#line 1242 "new-messages-monitor.c"
			}
#line 188 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp17_ = info;
#line 188 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp18_ = _tmp17_->new_ids;
#line 188 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp19_ = email_id;
#line 188 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email_id);
#line 1254 "new-messages-monitor.c"
		}
#line 182 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_id_it);
#line 1258 "new-messages-monitor.c"
	}
#line 191 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp20_ = info;
#line 191 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, _tmp20_, FALSE);
#line 178 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 1266 "new-messages-monitor.c"
}


void new_messages_monitor_clear_new_messages (NewMessagesMonitor* self, GearyFolder* folder) {
	GeeHashMap* _tmp0_;
	GearyFolder* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp3_;
	GearyFolder* _tmp4_;
	gpointer _tmp5_ = NULL;
	NewMessagesMonitorMonitorInformation* info;
	GeeHashSet* _tmp6_;
#line 194 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 194 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 195 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 195 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = folder;
#line 195 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 195 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_vala_assert (_tmp2_, "folder_information.has_key(folder)");
#line 196 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = self->priv->folder_information;
#line 196 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = folder;
#line 196 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 196 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp5_;
#line 198 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = info->new_ids;
#line 198 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 199 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_last_new_message_folder (self, NULL);
#line 200 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_last_new_message (self, NULL);
#line 202 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, info, FALSE);
#line 194 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 1311 "new-messages-monitor.c"
}


void new_messages_monitor_clear_all_new_messages (NewMessagesMonitor* self) {
#line 205 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 1318 "new-messages-monitor.c"
	{
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _folder_it;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = self->priv->folder_information;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap));
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp2_ = _tmp1_;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp3_ = _tmp2_;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp5_ = _tmp4_;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_tmp3_);
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_folder_it = _tmp5_;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1345 "new-messages-monitor.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			GearyFolder* folder;
			GearyFolder* _tmp10_;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = _folder_it;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			if (!_tmp7_) {
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
				break;
#line 1360 "new-messages-monitor.c"
			}
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = _folder_it;
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			folder = (GearyFolder*) _tmp9_;
#line 207 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_tmp10_ = folder;
#line 207 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_clear_new_messages (self, _tmp10_);
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (folder);
#line 1374 "new-messages-monitor.c"
		}
#line 206 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_folder_it);
#line 1378 "new-messages-monitor.c"
	}
}


static void new_messages_monitor_update_count (NewMessagesMonitor* self, NewMessagesMonitorMonitorInformation* info, gboolean arrived) {
	NewMessagesMonitorMonitorInformation* _tmp0_;
	GeeHashSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint new_size;
	NewMessagesMonitorMonitorInformation* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	NewMessagesMonitorMonitorInformation* _tmp9_;
	gint _tmp10_;
	NewMessagesMonitorMonitorInformation* _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_;
#line 210 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 210 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION (info));
#line 211 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = info;
#line 211 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _tmp0_->new_ids;
#line 211 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 211 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _tmp2_;
#line 211 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_size = _tmp3_;
#line 216 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = info;
#line 216 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = _tmp4_->count;
#line 216 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = new_size;
#line 216 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	if (_tmp5_ == _tmp6_) {
#line 217 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		return;
#line 1423 "new-messages-monitor.c"
	}
#line 219 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp7_ = self->priv->_total_count;
#line 219 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp8_ = new_size;
#line 219 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp9_ = info;
#line 219 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp10_ = _tmp9_->count;
#line 219 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_total_count (self, _tmp7_ + (_tmp8_ - _tmp10_));
#line 220 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp11_ = info;
#line 220 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp12_ = new_size;
#line 220 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp11_->count = _tmp12_;
#line 222 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp13_ = arrived;
#line 222 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	if (_tmp13_) {
#line 1445 "new-messages-monitor.c"
		NewMessagesMonitorMonitorInformation* _tmp14_;
		GearyFolder* _tmp15_;
		NewMessagesMonitorMonitorInformation* _tmp16_;
		gint _tmp17_;
#line 223 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp14_ = info;
#line 223 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp15_ = _tmp14_->folder;
#line 223 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp16_ = info;
#line 223 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp17_ = _tmp16_->count;
#line 223 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_signal_emit_by_name (self, "new-messages-arrived", _tmp15_, _tmp17_);
#line 1460 "new-messages-monitor.c"
	} else {
		NewMessagesMonitorMonitorInformation* _tmp18_;
		GearyFolder* _tmp19_;
		NewMessagesMonitorMonitorInformation* _tmp20_;
		gint _tmp21_;
#line 225 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp18_ = info;
#line 225 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp19_ = _tmp18_->folder;
#line 225 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp20_ = info;
#line 225 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		_tmp21_ = _tmp20_->count;
#line 225 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_signal_emit_by_name (self, "new-messages-retired", _tmp19_, _tmp21_);
#line 1476 "new-messages-monitor.c"
	}
}


GearyEmailField new_messages_monitor_get_required_fields (NewMessagesMonitor* self) {
	GearyEmailField result;
	GearyEmailField _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1492 "new-messages-monitor.c"
}


static void new_messages_monitor_set_required_fields (NewMessagesMonitor* self, GearyEmailField value) {
	GearyEmailField _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_required_fields = _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "required-fields");
#line 1506 "new-messages-monitor.c"
}


gint new_messages_monitor_get_total_count (NewMessagesMonitor* self) {
	gint result;
	gint _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_total_count;
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1521 "new-messages-monitor.c"
}


static void new_messages_monitor_set_total_count (NewMessagesMonitor* self, gint value) {
	gint _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_total_count = _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "total-count");
#line 1535 "new-messages-monitor.c"
}


GearyFolder* new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self) {
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_last_new_message_folder;
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1550 "new-messages-monitor.c"
}


static void new_messages_monitor_set_last_new_message_folder (NewMessagesMonitor* self, GearyFolder* value) {
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message_folder);
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message_folder = _tmp1_;
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "last-new-message-folder");
#line 1569 "new-messages-monitor.c"
}


GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self) {
	GearyEmail* result;
	GearyEmail* _tmp0_;
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_last_new_message;
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1584 "new-messages-monitor.c"
}


static void new_messages_monitor_set_last_new_message (NewMessagesMonitor* self, GearyEmail* value) {
	GearyEmail* _tmp0_;
	GearyEmail* _tmp1_;
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message);
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message = _tmp1_;
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "last-new-message");
#line 1603 "new-messages-monitor.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		data1 = closure->data;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 1622 "new-messages-monitor.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		data2 = closure->data;
#line 1628 "new-messages-monitor.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 1634 "new-messages-monitor.c"
}


static guint _geary_hashable_hash_func_ghash_func (gconstpointer key) {
	guint result;
	result = geary_hashable_hash_func (key);
#line 21 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1643 "new-messages-monitor.c"
}


static gboolean _geary_equalable_equal_func_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = geary_equalable_equal_func (a, b);
#line 21 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1652 "new-messages-monitor.c"
}


static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_construct (GType object_type, GearyFolder* folder, GCancellable* cancellable) {
	NewMessagesMonitorMonitorInformation * self = NULL;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
#line 25 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), NULL);
#line 25 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 25 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self = (NewMessagesMonitorMonitorInformation*) geary_base_object_construct (object_type);
#line 26 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = folder;
#line 26 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 26 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->folder);
#line 26 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->folder = _tmp1_;
#line 27 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = cancellable;
#line 27 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 27 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->cancellable);
#line 27 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->cancellable = _tmp3_;
#line 25 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return self;
#line 1686 "new-messages-monitor.c"
}


static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_new (GearyFolder* folder, GCancellable* cancellable) {
#line 25 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	return new_messages_monitor_monitor_information_construct (NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, folder, cancellable);
#line 1693 "new-messages-monitor.c"
}


static void new_messages_monitor_monitor_information_class_init (NewMessagesMonitorMonitorInformationClass * klass) {
#line 17 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_monitor_information_parent_class = g_type_class_peek_parent (klass);
#line 17 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = new_messages_monitor_monitor_information_finalize;
#line 1702 "new-messages-monitor.c"
}


static void new_messages_monitor_monitor_information_instance_init (NewMessagesMonitorMonitorInformation * self) {
	GeeHashSet* _tmp0_;
#line 19 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->cancellable = NULL;
#line 20 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->count = 0;
#line 21 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_hash_set_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, _geary_hashable_hash_func_ghash_func, _geary_equalable_equal_func_gequal_func);
#line 21 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->new_ids = _tmp0_;
#line 1716 "new-messages-monitor.c"
}


static void new_messages_monitor_monitor_information_finalize (GObject* obj) {
	NewMessagesMonitorMonitorInformation * self;
#line 17 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformation);
#line 18 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->folder);
#line 19 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->cancellable);
#line 21 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->new_ids);
#line 17 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (new_messages_monitor_monitor_information_parent_class)->finalize (obj);
#line 1732 "new-messages-monitor.c"
}


static GType new_messages_monitor_monitor_information_get_type (void) {
	static volatile gsize new_messages_monitor_monitor_information_type_id__volatile = 0;
	if (g_once_init_enter (&new_messages_monitor_monitor_information_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewMessagesMonitorMonitorInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_messages_monitor_monitor_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewMessagesMonitorMonitorInformation), 0, (GInstanceInitFunc) new_messages_monitor_monitor_information_instance_init, NULL };
		GType new_messages_monitor_monitor_information_type_id;
		new_messages_monitor_monitor_information_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "NewMessagesMonitorMonitorInformation", &g_define_type_info, 0);
		g_once_init_leave (&new_messages_monitor_monitor_information_type_id__volatile, new_messages_monitor_monitor_information_type_id);
	}
	return new_messages_monitor_monitor_information_type_id__volatile;
}


static void new_messages_monitor_class_init (NewMessagesMonitorClass * klass) {
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_type_class_add_private (klass, sizeof (NewMessagesMonitorPrivate));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_new_messages_monitor_get_property;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_new_messages_monitor_set_property;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = new_messages_monitor_finalize;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_REQUIRED_FIELDS, g_param_spec_enum ("required-fields", "required-fields", "required-fields", GEARY_EMAIL_TYPE_FIELD, GEARY_EMAIL_FIELD_FLAGS, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_TOTAL_COUNT, g_param_spec_int ("total-count", "total-count", "total-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER, g_param_spec_object ("last-new-message-folder", "last-new-message-folder", "last-new-message-folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE, g_param_spec_object ("last-new-message", "last-new-message", "last-new-message", GEARY_TYPE_EMAIL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_new ("folder_added", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_FOLDER);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_new ("folder_removed", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_FOLDER);
#line 1771 "new-messages-monitor.c"
	/**
	     * Fired when the monitor finds new messages on a folder.  The count
	     * argument is the updated count of new messages in that folder, not the
	     * number of messages just added.
	     */
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_new ("new_messages_arrived", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, G_TYPE_INT);
#line 1779 "new-messages-monitor.c"
	/**
	     * Fired when the monitor clears the "new" status of some messages in the
	     * folder.  The count argument is the updated count of new messages in that
	     * folder, not the number of messages just retired.
	     */
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	g_signal_new ("new_messages_retired", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, G_TYPE_INT);
#line 1787 "new-messages-monitor.c"
}


static void new_messages_monitor_instance_init (NewMessagesMonitor * self) {
	GeeHashMap* _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv = NEW_MESSAGES_MONITOR_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_required_fields = GEARY_EMAIL_FIELD_FLAGS;
#line 32 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_total_count = 0;
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message_folder = NULL;
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message = NULL;
#line 36 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_hash_map_new (GEARY_TYPE_FOLDER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 36 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self->priv->folder_information = _tmp0_;
#line 1807 "new-messages-monitor.c"
}


static void new_messages_monitor_finalize (GObject* obj) {
	NewMessagesMonitor * self;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 33 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message_folder);
#line 34 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message);
#line 36 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->folder_information);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (new_messages_monitor_parent_class)->finalize (obj);
#line 1823 "new-messages-monitor.c"
}


GType new_messages_monitor_get_type (void) {
	static volatile gsize new_messages_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&new_messages_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewMessagesMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_messages_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewMessagesMonitor), 0, (GInstanceInitFunc) new_messages_monitor_instance_init, NULL };
		GType new_messages_monitor_type_id;
		new_messages_monitor_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "NewMessagesMonitor", &g_define_type_info, 0);
		g_once_init_leave (&new_messages_monitor_type_id__volatile, new_messages_monitor_type_id);
	}
	return new_messages_monitor_type_id__volatile;
}


static void _vala_new_messages_monitor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_enum (value, new_messages_monitor_get_required_fields (self));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_TOTAL_COUNT:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_int (value, new_messages_monitor_get_total_count (self));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_last_new_message_folder (self));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_last_new_message (self));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1868 "new-messages-monitor.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1874 "new-messages-monitor.c"
	}
}


static void _vala_new_messages_monitor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_required_fields (self, g_value_get_enum (value));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_TOTAL_COUNT:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_total_count (self, g_value_get_int (value));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_last_new_message_folder (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_last_new_message (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1908 "new-messages-monitor.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.3.1/src/client/notification/new-messages-monitor.vala"
		break;
#line 1914 "new-messages-monitor.c"
	}
}



